# C++ client interface generation rules.
#
# Copyright (C) 2020, 2022, 2023 Paul Boddie <paul@boddie.org.uk>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor,
# Boston, MA  02110-1301, USA

define client_interface_cc_template =
$(1)_CLIENT	= $(call interfaces_to_client_cc_h,$(1))
$(1)_CLIENT_IDL	= $(call interfaces_to_idl,$(1))
$(1)_CLIENT_CC_	= $(IDL_BUILD_DIR)/__client_cc__$(1)

# Reference interfaces if exported.

ifdef IDL_EXPORT_DIR
$(1)_CLIENT_INC	= $(call export_includes,$(call interfaces_to_interface_h,$(1)))
endif

# All generated files depend on a target file produced by a single invocation of
# the idl command. Where any generated files are missing, the invocation is
# performed again.

$$(foreach FILENAME,$$($(1)_CLIENT),$$(if $$(wildcard $$(FILENAME)),,$$(shell rm -f $$($(1)_CLIENT_CC_))))

$$($(1)_CLIENT): $$($(1)_CLIENT_CC_)
	@touch $$@

$$($(1)_CLIENT_CC_): $$($(1)_CLIENT_IDL) $$($(1)_CLIENT_INC) $(IDL_PROG)
	$(IDL_PROG) $(IDL_ARGS) -d $(IDL_BUILD_DIR) --client --headers --routines --language=c++ $$($(1)_CLIENT_IDL)
	@touch $$@
endef
